%% load data

% load reconstructed 3D volume
Dsetvol = importdata('FePt_final_reconstruction_volume.mat');

% apply very loose binary support to exclude artifact peaks far away from the
% nanoparticle
Support = importdata('Loose_Support.mat');
Dsetvol = Dsetvol.*Support;

% intensity threshold for the local maxima pixel
% local maxima with intensity less than this value will not be traced
% because they are way too weak to become actual atoms
Th = 0.01;

% prefix for output file
ourputstring = 'Peak_TracingFePt';

% zero padd the reconstructed volume
Sdn_pad = zeros(276,276,276);
Sdn_pad(11:266,11:266,11:266) = Dsetvol;
Sdenoise_all_2 = Sdn_pad;
clear Sdn_pad Support Dsetvol

%% Init some variables

% Pixel Resolution in Angstroem
Res = 0.3725;


BoxSize0=3; %box size used for average when sorting peaks
BoxSize1=5; %box size used to find maxima
BoxSize2=7; %box size used box for fitting off-center gauss
BoxSize3=7; %used to compute visualization matrix

[Xsize, Ysize, Zsize] = size(Sdenoise_all_2);  

%% Trace peaks
    
MaxNumberPeaks=40000; %maximum number of peaks to find


% minimum distance constraint in the unit of pixel
Dmin = 5.3706; % this corresponds to 2 Angstrom for FePt reconstruction

    
DataMatrix = Sdenoise_all_2;
%%
%find possible atoms (minimal distance contraint applied)
% atom_pos is the xyz positions (in the unit of pixel) of found local maxima peaks
% close_pos is the xyz positions of peaks which violate the minimum distance constraint
% statsI is the initial Gaussian fitting parameters of each peak
% stats is the final Gaussian fitting parameters of each peak
[atom_pos, close_pos,  statsI, stats ] = find_possible_atoms(DataMatrix, Dmin, MaxNumberPeaks, BoxSize0, BoxSize1,BoxSize2,Th);


%save result
eval(['save ' DataName '_' ourputstring '_step' num2str(TracingStep)  '.mat atom_pos close_pos Dmin stats statsI DataMatrix MaxNumberPeaks'])



 